//@ts-ignore
export function resolveFormPathFollow(strings, ...vals) {
    return vals[0].replace('[]', vals[1]);
}
export function resolveEventPathParam(formJsonPath, formPath, filterErrorValue, errorAtIndex) {
    let controlPaths;
    if (formJsonPath) {
        if (errorAtIndex === undefined) {
            errorAtIndex = [];
        }
        controlPaths = extractTemplatePath(formJsonPath, filterErrorValue, errorAtIndex);
    }
    else {
        if (formPath && !Array.isArray(formPath)) {
            controlPaths = [formPath];
        }
        else {
            controlPaths = Array.isArray(formPath) ? formPath : [];
        }
    }
    return controlPaths;
}
export function removeErrorFromControllers(controlPaths, f, eventType) {
    controlPaths.forEach(controlPath => {
        const control = f.get(controlPath);
        if (!(control === null || control === void 0 ? void 0 : control.errors))
            return;
        const errors = filterOutErrorsByType(control.errors, eventType);
        // console.log('errors', errors);
        control.setErrors(Object.keys(errors).length == 0 ? null : errors);
    });
}
export function filterOutErrorsByType(errors, eventType) {
    return Object.assign({}, ...Object.entries(errors)
        .filter(([k, v]) => k !== eventType).map(([k, v]) => ({ [k]: v })));
}
export function extractTemplatePath(formJsonPath, filterErrorValue, errorAtIndex) {
    if (errorAtIndex === undefined) {
        return [];
    }
    return Object.entries(errorAtIndex)
        .filter(([key, val]) => val === filterErrorValue)
        .map(([key, val]) => resolveFormPathFollow `${formJsonPath} ${key}`);
}
//# sourceMappingURL=rules-engine-form-helpers.js.map